## ros-iron-rosidl-runtime-c 4.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_runtime_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_typesupport_interface REQUIRED)

file(GLOB type_description_sources "src/type_description/*.c")
file(GLOB type_description_includes "include/rosidl_runtime_c/type_description/*.h")
add_library(${PROJECT_NAME}
  "src/message_type_support.c"
  "src/primitives_sequence_functions.c"
  "src/sequence_bound.c"
  "src/service_type_support.c"
  "src/string_functions.c"
  "src/type_hash.c"
  "src/u16string_functions.c"
  "src/type_description_utils.c"
  ${type_description_sources}
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
ament_target_dependencies(${PROJECT_NAME}
  "rcutils"
  "rosidl_typesupport_interface")
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set_target_properties(${PROJECT_NAME} PROPERTIES
    COMPILE_OPTIONS -Wall -Wextra -Wpedantic)
endif()
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "ROSIDL_GENERATOR_C_BUILDING_DLL")
endif()

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

ament_export_dependencies(rcutils rosidl_typesupport_interface)

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_runtime_packages")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS performance_test_fixture::performance_test_fixture
    INTERFACE_INCLUDE_DIRECTORIES)

  set(AMENT_LINT_AUTO_FILE_EXCLUDE ${type_description_includes} ${type_description_sources})
  ament_lint_auto_find_test_dependencies()

  # Run specific linters on copied generated code
  if(ament_cmake_cppcheck_FOUND)
    ament_cppcheck(
      TESTNAME "cppcheck_copied_type_description_interfaces"
      ${type_description_includes} ${type_description_sources})
  endif()
  if(ament_cmake_cpplint_FOUND)
    ament_cpplint(
      TESTNAME "cpplint_copied_type_description_interfaces"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 999
      ${type_description_includes} ${type_description_sources})
  endif()
  if(ament_cmake_uncrustify_FOUND)
    ament_uncrustify(
      TESTNAME "uncrustify_copied_type_description_interfaces"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 0
      ${type_description_includes} ${type_description_sources})
  endif()

  # For gtest
  enable_language(CXX)
  # Default to C++17
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
  endif()

  find_package(ament_cmake_gtest REQUIRED)

  ament_add_gtest(test_message_type_support test/test_message_type_support.cpp)
  if(TARGET test_message_type_support)
    target_link_libraries(test_message_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_primitives_sequence_functions test/test_primitives_sequence_functions.cpp)
  if(TARGET test_primitives_sequence_functions)
    target_link_libraries(test_primitives_sequence_functions ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_sequence_bound test/test_sequence_bound.cpp)
  if(TARGET test_sequence_bound)
    ament_target_dependencies(test_sequence_bound
      "rosidl_typesupport_interface")
    target_link_libraries(test_sequence_bound ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_service_type_support test/test_service_type_support.cpp)
  if(TARGET test_service_type_support)
    target_link_libraries(test_service_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_string_functions test/test_string_functions.cpp)
  if(TARGET test_string_functions)
    target_link_libraries(test_string_functions ${PROJECT_NAME})
    target_compile_definitions(test_string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_type_hash test/test_type_hash.cpp)
  if(TARGET test_type_hash)
    target_link_libraries(test_type_hash ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_u16string_functions test/test_u16string_functions.cpp)
  if(TARGET test_u16string_functions)
    target_link_libraries(test_u16string_functions ${PROJECT_NAME})
    target_compile_definitions(test_u16string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_type_description_utils test/test_type_description_utils.cpp)
  if(TARGET test_type_description_utils)
    target_link_libraries(test_type_description_utils ${PROJECT_NAME})
  endif()

  add_performance_test(benchmark_string_conversion test/benchmark/benchmark_string_conversion.cpp)
  if(TARGET benchmark_string_conversion)
    target_link_libraries(benchmark_string_conversion ${PROJECT_NAME})
  endif()
endif()

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_package()

=== debian/changelog ===
ros-iron-rosidl-runtime-c (4.0.1-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 13 Jul 2023 16:00:00 -0000

ros-iron-rosidl-runtime-c (4.0.0-1jammy) jammy; urgency=high

  * Dynamic Subscription (BONUS: Allocators): rosidl (#737 <https://github.com/ros2/rosidl/issues/737>)
  * Runtime Interface Reflection: rosidl (#728 <https://github.com/ros2/rosidl/issues/728>)
  * Type Description Codegen and Typesupport  (rep2011) (#727 <https://github.com/ros2/rosidl/issues/727>)
  * Copied type_description_interfaces structs (rep2011) (#732 <https://github.com/ros2/rosidl/issues/732>)
  * Expose type hash on typesupports (rep2011) (#729 <https://github.com/ros2/rosidl/issues/729>)
  * Type hash in interface codegen (rep2011) (#722 <https://github.com/ros2/rosidl/issues/722>)
  * Contributors: Emerson Knapp, methylDragon

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 10 Apr 2023 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.4.0-1jammy) jammy; urgency=high

  * [service introspection] generate service_event messages (#700 <https://github.com/ros2/rosidl/issues/700>)
  * [rolling] Update maintainers - 2022-11-07 (#717 <https://github.com/ros2/rosidl/issues/717>)
  * Contributors: Audrow Nash, Brian

 -- Aditya Pande <aditya.pande@openrobotics.org>  Sun, 12 Feb 2023 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.3.1-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 01 Nov 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.3.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 07 Sep 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.2.1-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 20 Jun 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.2.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 03 May 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.1.3-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 07 Apr 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.1.2-1jammy) jammy; urgency=high

  * Fix error handling when copying C sequence messages (#671 <https://github.com/ros2/rosidl/issues/671>)
  * Contributors: Michel Hidalgo

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 04 Apr 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.1.1-1jammy) jammy; urgency=high

  * Set the output size unconditionally when copying sequences (#669 <https://github.com/ros2/rosidl/issues/669>)
  * Contributors: Nikolai Morin

 -- Aditya Pande <aditya.pande@openrobotics.org>  Sun, 27 Mar 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.1.0-1jammy) jammy; urgency=high

  * De-duplicate Quality Level from README and QUALITY_DECLARATION (#661 <https://github.com/ros2/rosidl/issues/661>)
  * Install headers to include/${PROJECT_NAME} (#658 <https://github.com/ros2/rosidl/issues/658>)
  * Implement copy function for C messages (#650 <https://github.com/ros2/rosidl/issues/650>)
  * Implement equality operator function for C messages. (#648 <https://github.com/ros2/rosidl/issues/648>)
  * Contributors: Jose Luis Rivero, Michel Hidalgo, Shane Loretz

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 28 Feb 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.0.1-1jammy) jammy; urgency=high

  * Set CXX standard to 17 (#635 <https://github.com/ros2/rosidl/issues/635>)
  * Contributors: Øystein Sture

 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 12 Jan 2022 16:00:00 -0000

ros-iron-rosidl-runtime-c (3.0.0-1jammy) jammy; urgency=high

  * Update package maintainers (#624 <https://github.com/ros2/rosidl/issues/624>)
  * Contributors: Michel Hidalgo

 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 04 Nov 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.5.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 09 Aug 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.4.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Sun, 11 Jul 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.3.0-1jammy) jammy; urgency=high

  * Use RCUtils allocators in rosidl_generator_c (#584 <https://github.com/ros2/rosidl/issues/584>)
  * Contributors: Pablo Garrido

 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 10 Jun 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.2.1-1jammy) jammy; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#581 <https://github.com/ros2/rosidl/issues/581>)
  * Contributors: shonigmann

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 05 Apr 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.2.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 17 Mar 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.1.0-1jammy) jammy; urgency=high

  * Shorten some excessively long lines of CMake (#571 <https://github.com/ros2/rosidl/issues/571>)
  * Contributors: Scott K Logan

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 08 Mar 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.0.3-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Sun, 24 Jan 2021 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.0.2-1jammy) jammy; urgency=high

  * Update and add package.xml descriptions to README (#553 <https://github.com/ros2/rosidl/issues/553>)
  * Fix item number in QD (#546 <https://github.com/ros2/rosidl/issues/546>)
  * Update the maintainers of this repository. (#536 <https://github.com/ros2/rosidl/issues/536>)
  * Contributors: Chris Lalancette, Louise Poubel, Shane Loretz

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 07 Dec 2020 16:00:00 -0000

ros-iron-rosidl-runtime-c (2.0.1-1jammy) jammy; urgency=high

  * Add rcutils dependency. (#534 <https://github.com/ros2/rosidl/issues/534>)
  * QD: Add links to hosted API docs (#533 <https://github.com/ros2/rosidl/issues/533>)


=== debian/control ===
Source: ros-iron-rosidl-runtime-c
Section: misc
Priority: optional
Maintainer: Aditya Pande <aditya.pande@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-performance-test-fixture <!nocheck>, ros-iron-rcutils, ros-iron-rosidl-typesupport-interface, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rosidl-runtime-c
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-ament-cmake, ros-iron-rcutils, ros-iron-rosidl-typesupport-interface, ros-iron-ros-workspace
Description: Provides definitions, initialization and finalization functions, and macros for getting and working with rosidl typesupport types in C.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rosidl-runtime-c//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
